Subject: RE: Uniform Probabilistic Sampling in PSAMP-PROTO

From: "Thomas Dietz" <[email-masked]>
Date: Wed, 21 Dec 2005 16:54:30 +0100

Dear all,

I would also vote for solution 1 or 2. If we choose solution 2 then we
should adjust the value as Benoit suggested.

Regards,

Thomas

-- 
Thomas Dietz                       E-mail: [email-masked]
Network Laboratories               Phone:  +49 6221 90511-28
NEC Europe Ltd.                    Fax:    +49 6221 90511-55
Kurfuersten-Anlage 36
69115 Heidelberg, Germany          http://www.netlab.nec.de

> -----Original Message-----
> From: [email-masked] 
> [mailto:[email-masked]] On Behalf Of Juergen Quittek
> Sent: Wednesday, December 21, 2005 12:16 PM
> To: Andrew Johnson; Benoit Claise
> Cc: psamp
> Subject: Re: Uniform Probabilistic Sampling in PSAMP-PROTO
> 
> Hi Andrew,
> 
> --On 08.12.2005 16:53 Uhr +0000 Andrew Johnson wrote:
> 
> > Benoit Claise wrote:
> > [SNIP]
> >> Initially we wanted to model the probability in 
> [PSAMP-PROTO] with a
> >> float, which is allowed by [IPFIX-PROTO].
> >> However, we've got the issue that SMIv2 doesn't support floats.
> >
> > Although the floating point type is not a base type in SMI there are
> > a couple of proposals about how to send them.  This extract is from
> > the comp.protocols.snmp SNMP FAQ:
> >
> >   http://www.faqs.org/faqs/snmp-faq/part2/
> >   ===============================================================
> >   2.40.04
> >   SUBJECT: Floating Point Numbers in SMI?
> >
> >   You cannot add new base types to the SMI.
> >
> >   For now, the easiest way to have floating point numbers
> >   in SNMP MIBs is to use the base type OCTET STRING and
> >   encode the value in ASCII.
> >
> >   This is not the most elegant approach. However, it will work
> >   between your agent and your management application and it will
> >   be compliant to the SNMP SMI and protocol specifications.
> >
> >   David Perkins
> >   ===============================================================
> >
> > Apparently this method is implemented in the NET-SNMP agent and
> > manager.
> >   (http://ops.ietf.org/lists/mreview/mreview.2004/msg00083.html)
> >
> > Whether we use the above suggested method or define a new way of
> > using unsigned32 the application will have to have some way of
> > converting that number before it can be used.
> 
> This would be Solution 4.
> I still prefer Solution 1 or Solution 2.
> 
> >> What to do now?
> >>
> >> _Solution 1: _
> >> We export the probability with a float, and we approximate 
> this value
> >> with the MIB variable.
> >>
> >> _Solution 2: _
> >> We export the probability with an unsigned32, exactly the 
> same content
> >> as the MIB variable psampSampUniProbProbability
> >>
> >> _Solution 3: _
> >> We export the probability with two values N, M.
> >>     This means 2 inter-dependent I.E.s and 2 MIB variables 
> instead of one.
> >>     I don't like it too much
> >>
> >> I'm clearly in favor of solution 1. It's not right that we 
> would limit
> >> IPFIX because of the limitations of SMIv2
> >> Feedback?
> >>
> >> Side question: if we go for the float solution, should we have a
> >> float64? This would give us more precision
> >> Note: not yet defined in [IPFIX-PROTO].
> >
> > FYI:
> > The 32-bit float has 24 bits of precision, i.e. roughly 
> +/-0.000006%.
> 
> It is 23 bits we are using. Precision would be    roughly +/-0.00001%
> The Unsigned as Benoit suggests it would have     roughly 
> +/-0.0000001%
> 
> > The 64-bit float has 53 bits of precision, i.e. roughly 
> +/-0.00000000000001%
> > regards
> 
> Thanks,
> 
>     Juergen
> 
> > Andrew
> >
> > --
> > to unsubscribe send a message to [email-masked] with
> > the word 'unsubscribe' in a single line as the message text body.
> > archive: <http://ops.ietf.org/lists/psamp/>
> 
> 
> 
> --
> to unsubscribe send a message to [email-masked] with
> the word 'unsubscribe' in a single line as the message text body.
> archive: <http://ops.ietf.org/lists/psamp/>
>